Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.search
Class JoinQualification

    java.lang.Object
      oracle.ifs.search.SearchQualification
          oracle.ifs.search.JoinQualification

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

    public class JoinQualification

extends SearchQualification

The JoinQualification represents a join condition. A join condition has two attributes, which are tested for equality. There is no support for joining on other comparison operators. There is no support for joining on array type Attributes, and Class Properties.

A null Attribute Name implies joining on the Object's id. When you have more than one search class in your search specification, they all must be joined using appropriate join conditions. Failure to do so will result in cartesian join of the search classes for which there is no join condition.

Below is an example of constructing JoinQualification. For a example with a complete search tree, look at javadoc for AttributeSearchSpecification or ContextSearchSpecification.

>      //
>      // Usage Examples
>      //
>      //
>      // Joining on a scalar attribute
>      // Joining Document with DirectoryUser
>      // Generates SQL of the form DOCUMENT.Owner = DIRECTORYUSER.Id
>      JoinQualification jq1 = new JoinQualification();
>      jq1.setLeftAttribute(Document.CLASS_NAME, PublicObject.OWNER_ATTRIBUTE);
>      // Note the 'null' being passed for attribute. That implies
>      // joining on ID.
>      jq2.setRightAttribute(DirectoryUser.CLASS_NAME, null);

See Also:
  Serialized Form
(Published)

Field Summary
`static int` | `LHS` Constant used to identify the Left-hand-Side of the join condition.
`protected java.lang.String[]` | `m_Attribute` Holds onto the LHS and RHS Attributes.
`protected java.lang.String[]` | `m_Class` Holds onto the LHS and RHS Classes
`static int` | `RHS` Constant used to identify the Right-hand-Side of the join condition.

Fields inherited from class oracle.ifs.search.SearchQualification
`LATE_BIND_OPER`

Constructor Summary
`JoinQualification()` Constructs an JoinQualification.

Method Summary
`protected void` | `accept(oracle.ifs.search.SearchQualificationVisitor v)` Accepts a SearchQualificationVisitor.
`java.lang.Object` | `clone()` Returns a clone of this SearchQualification.
`java.lang.String` | `getLeftAttributeClassname()` Gets the classname of left side of this join qualification.
`java.lang.String` | `getLeftAttributeName()` Gets the unqualified attribute name of the left side of this join qualification.
`java.lang.String` | `getRightAttributeClassname()` Gets the classname of right side of this join qualification.
`java.lang.String` | `getRightAttributeName()` Gets the unqualified attribute name of the right side of this join qualification.
`void` | `setLeftAttribute(java.lang.String className, java.lang.String attrName)` Set left hand side Join Attribute.
`void` | `setRightAttribute(java.lang.String className, java.lang.String attrName)` Set right hand side Join Attribute.

Methods inherited from class oracle.ifs.search.SearchQualification
`isLateBound`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### LHS

    public static final int LHS

  Description copied from class: `JoinQualification`
  Constant used to identify the Left-hand-Side of the join condition.

  See Also:
    Constant Field Values
  (Unpublished)

### RHS

    public static final int RHS

  Description copied from class: `JoinQualification`
  Constant used to identify the Right-hand-Side of the join condition.

  See Also:
    Constant Field Values
  (Unpublished)

### m_Class

    protected java.lang.String[] m_Class

  Description copied from class: `JoinQualification`
  Holds onto the LHS and RHS Classes

  (Unpublished)

### m_Attribute

    protected java.lang.String[] m_Attribute

  Description copied from class: `JoinQualification`
  Holds onto the LHS and RHS Attributes.

  (Unpublished)

Constructor Detail

### JoinQualification

    public JoinQualification()

  Constructs an JoinQualification. There are no defaults for LHS, RHS Classes and Attributes.

  (Published)

Method Detail

### setLeftAttribute

    public void setLeftAttribute(java.lang.String className,
                                 java.lang.String attrName)

  Description copied from class: `JoinQualification`
  Set left hand side Join Attribute. A null attrName implies that the Object's id must be used in the Join. A null Class is taken to mean, use the first Result Class of the SearchSpecification. Otherwise the className should be a valid iFS class, and attrName should be an attribute of the class.

  Parameters:
    `className` - The class of the attribute
    `attrName` - The joining Attribute
  See Also:
    `SearchSpecification`, `SearchClassSpecification`
  (Published)

### setRightAttribute

    public void setRightAttribute(java.lang.String className,
                                  java.lang.String attrName)

  Description copied from class: `JoinQualification`
  Set right hand side Join Attribute. A null attrName implies that the Object's id must be used in the Join. A null Class is taken to mean, use the first Result Class of the SearchSpecification. Otherwise the className should be a valid iFS class, and attrName should be an attribute of the class.

  Parameters:
    `className` - The class of the attribute
    `attrName` - The joining Attribute
  See Also:
    `SearchSpecification`, `SearchClassSpecification`
  (Published)

### getLeftAttributeName

    public java.lang.String getLeftAttributeName()
                                          throws IfsException

  Description copied from class: `JoinQualification`
  Gets the unqualified attribute name of the left side of this join qualification.

  Returns:
    unqualified attribute name of left hand side
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getRightAttributeName

    public java.lang.String getRightAttributeName()
                                           throws IfsException

  Description copied from class: `JoinQualification`
  Gets the unqualified attribute name of the right side of this join qualification.

  Returns:
    unqualified attribute name of right hand side
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getLeftAttributeClassname

    public java.lang.String getLeftAttributeClassname()
                                               throws IfsException

  Description copied from class: `JoinQualification`
  Gets the classname of left side of this join qualification.

  Returns:
    classname of left hand side
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getRightAttributeClassname

    public java.lang.String getRightAttributeClassname()
                                                throws IfsException

  Description copied from class: `JoinQualification`
  Gets the classname of right side of this join qualification.

  Returns:
    classname of right hand side
  Throws:
    `IfsException` - if the operation fails
  (Published)

### accept

    protected void accept(oracle.ifs.search.SearchQualificationVisitor v)
                   throws IfsException

  Description copied from class: `JoinQualification`
  Accepts a SearchQualificationVisitor. Calls visitJoinQualifier on the visitor. The code in visitJoinQualifier is specific to the Visitor.

  Specified by:
    `accept` in class `SearchQualification`
  Parameters:
    `v` - SearchQualificationVisitor
  Throws:
    `IfsException` - thrown if Visitor code throws.
  (Unpublished)

### clone

    public java.lang.Object clone()

  Description copied from class: `JoinQualification`
  Returns a clone of this SearchQualification.

  Overrides:
    `clone` in class `SearchQualification`
  Returns:
    Return a clone of this JoinQualification.
  (Published)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD